<script setup lang="ts">
  const emit = defineEmits<{
    (e: 'close'): void;
  }>();

  const { likeList, likeListCount, isLikeListLoading, getLikeListStatistics } = useLikeList();
  const { permissionGranted } = useParticipants();
  const { requestDynamicPage } = useDynamicPage();

  const handleFilter = async (criteria: { order: string; sort: string }) => {
    await getLikeListStatistics(criteria.order, criteria.sort);
  };

  const openLikeListPage = () => {
    requestDynamicPage({
      type: DynamicPageType.LIKE_LIST,
    });
  };
</script>

<template>
  <InteractionTemplateSidebar
    name="like-list-sidebar"
    :loading="isLikeListLoading"
    :count="likeListCount"
    :items="likeList"
    granted-permission
    allow-open-page
    @open-page="openLikeListPage"
    @close="emit('close')"
    @filter="handleFilter"
  >
    <template #title>
      {{ $t('wishlist.header') }}
    </template>
    <template #empty-icon>
      <span class="i-sw-solid:heart" />
    </template>
    <template #empty-label="{ isAllSelected }">
      {{ isAllSelected ? $t('wishlist.guideEmptyLabel') : $t('wishlist.emptyLabel') }}
    </template>
    <template #empty-description="{ isAllSelected }">
      {{ isAllSelected ? $t('wishlist.guideEmptyDescription') : $t('wishlist.emptyDescription') }}
    </template>
    <template #item="{ item, isAllSelected }">
      <LikedProductItem
        :data="item"
        :readonly="isAllSelected"
        :permission-granted="permissionGranted"
      />
    </template>
  </InteractionTemplateSidebar>
</template>
